--global variables
global unitsType

--functions
fn RotatePivotOnly obj rotation = (
local rotValInv=inverse (rotation as quat)
in coordsys local obj.rotation*=RotValInv
obj.objectoffsetrot*=RotValInv
obj.objectoffsetpos*=RotValInv
)

fn getUnits = (
	case of (
		 (units.SystemType == #Millimeters) :unitsType = 1000
	     (units.SystemType == #Centimeters) : unitsType = 100
	     (units.SystemType == #Meters) : unitsType = 10
	     (units.SystemType == #Kilometers) : unitsType = 1
	     default : (messagebox "This script doesn't support yours system units. Speed will be wrong!" tittle:"ERROR")
	)
)

rollout car_rig_creator "Car Rig Creator v0.6 rewriten" (

--local variables
	--base
	local wheelFL,wheelFR,wheelBL,wheelBR,SW,body,track,breakFL,breakFR,breakBL,breakBR,mainHelper,terrain_object
	--secondary
	local wheel_radius,axisY_Lenght,axisX_Lenght,wheelFL_conform_helper,wheelFR_conform_helper,wheelBL_conform_helper,wheelBR_conform_helper,currentSpeed,roll_controller
	local wheelFL_rotation_helper,wheelFR_rotation_helper,wheelBL_rotation_helper,wheelBR_rotation_helper
	--misc
	local front_axis_controller,back_axis_controller,middle_controller
	local roll_position,roll_rotation,main_position,main_rotation,rotationSW_helper,positionSW_helper

button pre "PRE-REQUIREMENTS" pos:[1,1] width:269 height:44 images:#(@"Z:\-- USERS\Frodo\crc\_images\crc_pre.jpg", @"Z:\-- USERS\Frodo\crc\_images\crc_pre_maska.bmp", 1, 1, 1, 1, 1) toolTip:"Read this before making any rig!"
	
button wheel_front_left "FL" pos:[1,85] width:73 height:73 images:#(@"Z:\-- USERS\Frodo\crc\_images\crc_kolo.jpg", @"Z:\-- USERS\Frodo\crc\_images\crc_kolo_maska.bmp", 1, 1, 1, 1, 1) toolTip:"Front left wheel: select objects and click this button."
button wheel_front_right "FR" pos:[195,85] width:73 height:73 images:#(@"Z:\-- USERS\Frodo\crc\_images\crc_kolo.jpg", @"Z:\-- USERS\Frodo\crc\_images\crc_kolo_maska.bmp", 1, 1, 1, 1, 1) toolTip:"Front right wheel: select objects and click this button."
button wheel_back_right "BR" pos:[195,235] width:73 height:73 images:#(@"Z:\-- USERS\Frodo\crc\_images\crc_kolo.jpg", @"Z:\-- USERS\Frodo\crc\_images\crc_kolo_maska.bmp", 1, 1, 1, 1, 1) toolTip:"Back right wheel: select objects and click this button."
button wheel_back_left "BL" pos:[1,235] width:73 height:73 images:#(@"Z:\-- USERS\Frodo\crc\_images\crc_kolo.jpg", @"Z:\-- USERS\Frodo\crc\_images\crc_kolo_maska.bmp", 1, 1, 1, 1, 1) toolTip:"Back left wheel: select objects and click this button."

button steering_wheel "SW" pos:[24,158] width:50 height:50 images:#(@"Z:\-- USERS\Frodo\crc\_images\crc_volant.jpg", @"Z:\-- USERS\Frodo\crc\_images\crc_volant_maska.bmp", 1, 1, 1, 1, 1) toolTip:"Steering Wheel: select objects and click this button."

button break_front_left "BFL" pos:[34,45] width:40 height:40 images:#(@"Z:\-- USERS\Frodo\crc\_images\crc_brzda.jpg", @"Z:\-- USERS\Frodo\crc\_images\crc_brzda_maska.bmp", 1, 1, 1, 1, 1) toolTip:"Front left break: select objects and click this button."
button break_front_right "BFR" pos:[195,45] width:40 height:40 images:#(@"Z:\-- USERS\Frodo\crc\_images\crc_brzda.jpg", @"Z:\-- USERS\Frodo\crc\_images\crc_brzda_maska.bmp", 1, 1, 1, 1, 1) toolTip:"Front right break: select objects and click this button."
button break_back_left "BBL" pos:[34,308] width:40 height:40 images:#(@"Z:\-- USERS\Frodo\crc\_images\crc_brzda.jpg", @"Z:\-- USERS\Frodo\crc\_images\crc_brzda_maska.bmp", 1, 1, 1, 1, 1) toolTip:"Back left break: select objects and click this button."
button break_back_right "BBR" pos:[195,308] width:40 height:40 images:#(@"Z:\-- USERS\Frodo\crc\_images\crc_brzda.jpg", @"Z:\-- USERS\Frodo\crc\_images\crc_brzda_maska.bmp", 1, 1, 1, 1, 1) toolTip:"Back right break: select objects and click this button."
	
button car_body "BODY" pos:[74,65] width:121 height:258 images:#(@"Z:\-- USERS\Frodo\crc\_images\crc_auto.jpg", @"Z:\-- USERS\Frodo\crc\_images\crc_auto_maska.bmp", 1, 1, 1, 1, 1) toolTip:"Body: select objects and click this button."
button car_path "TRACK" pos:[1,348] width:269 height:73 images:#(@"Z:\-- USERS\Frodo\crc\_images\crc_cesta.jpg", @"Z:\-- USERS\Frodo\crc\_images\crc_cesta_maska.bmp", 1, 1, 1, 1, 1) toolTip:"Track: select object and click this button. BECAREFULL! This is not the road mesh object, this is a 2D spline representing car ride over the terrain."

button measure_speed_btn "SPEED" pos:[1,421] width:30 height:30 images:#(@"Z:\-- USERS\Frodo\crc\_images\crc_rychlost.jpg", @"Z:\-- USERS\Frodo\crc\_images\crc_rychlost_maska.bmp", 1, 1, 1, 1, 1) toolTip:"Measure speed"
spinner drive_speed_kmh "" pos:[31,421] width:55 height:15 type:#integer range:[0,9999,50]
	label kmh_lbl "km/h" pos:[90,421]
spinner drive_speed_mph "" pos:[31,436] width:55 height:15 type:#integer range:[0,9999,31]
    label mph_lbl "mph" pos:[90,436]

button create "CREATE" pos:[120,421] width:149 height:31 images:#(@"Z:\-- USERS\Frodo\crc\_images\crc_create.jpg", @"Z:\-- USERS\Frodo\crc\_images\crc_create_maska.bmp", 1, 1, 1, 1, 1) toolTip:"Create the rig now!"

on car_rig_creator open do(clearListener())



on measure_speed_btn pressed do(
	getUnits()
	try(
	print ("Current speed: " + (((((distance (at time slidertime front_axis_controller.pos) (at time (slidertime+framerate) front_axis_controller.pos))/unitsType)*3.6)) as string) + " km/h")
	print ("Current speed: " + ((((((distance (at time slidertime front_axis_controller.pos) (at time (slidertime+framerate) front_axis_controller.pos))/unitsType)*3.6)*0.621)) as string) + " mph")
	)catch(print "Cant measure speed without rig!")
	)
	
on drive_speed_kmh changed val do(
	getUnits()
	try(
	local newSpeed = val
    local currentSpeed = (((distance (at time slidertime front_axis_controller.pos) (at time (slidertime+framerate) front_axis_controller.pos))/unitsType)*3.6)
    local ratio = (currentSpeed/newSpeed)

    local frame = getKeyTime front_axis_controller.position.controller.percent.controller 2
    local key = getKey front_axis_controller.position.controller.percent.controller 2

    key.time = frame*ratio
	)catch()
	drive_speed_mph.value = drive_speed_kmh.value*0.621
)

on drive_speed_mph changed val do(
	getUnits()
	try(
	local newSpeed = val*1.609
    local currentSpeed = (((distance (at time slidertime front_axis_controller.pos) (at time (slidertime+framerate) front_axis_controller.pos))/unitsType)*3.6)
    local ratio = (currentSpeed/newSpeed)

    local frame = getKeyTime front_axis_controller.position.controller.percent.controller 2
    local key = getKey front_axis_controller.position.controller.percent.controller 2

    key.time = frame*ratio
	)catch()
	drive_speed_kmh.value = drive_speed_mph.value*1.609
)

on wheel_front_left pressed do(
	if not selection.count == 1 then((messagebox "Select front left wheel!" title:"ERROR" beep:false style:#(#style_toolwindow,#style_sysmenu)))else(
		wheelFL = $
		print ("Front Left Wheel : "+(wheelFL.name as string))
		)
	)
on wheel_front_right pressed do(
	if not selection.count == 1 then((messagebox "Select front right wheel!" title:"ERROR" beep:false style:#(#style_toolwindow,#style_sysmenu)))else(
		wheelFR = $
		print ("Front Right Wheel : "+(wheelFR.name as string))
		)
	)
on wheel_back_left pressed do(
	if not selection.count == 1 then((messagebox "Select back left wheel!" title:"ERROR" beep:false style:#(#style_toolwindow,#style_sysmenu)))else(
		wheelBL = $
		print ("Back Left Wheel : "+(wheelBL.name as string))
		)
	)
on wheel_back_right pressed do(
	if not selection.count == 1 then((messagebox "Select back right wheel!" title:"ERROR" beep:false style:#(#style_toolwindow,#style_sysmenu)))else(
		wheelBR = $
		print ("Back Right Wheel : "+(wheelBR.name as string))
		)
	)
on steering_wheel pressed do(
	if not selection.count == 1 then((messagebox "Select steering wheel!" title:"ERROR" beep:false style:#(#style_toolwindow,#style_sysmenu)))else(
		SW = $
		print ("Steering Wheel : "+(SW.name as string))
		)
	)
on car_body pressed do(
	if not selection.count == 1 then((messagebox "Select car body!" title:"ERROR" beep:false style:#(#style_toolwindow,#style_sysmenu)))else(
		body = $
		print ("Body : "+(body.name as string))
		)
	)
on car_path pressed do(
	if not selection.count == 1 then((messagebox "Select drive path!" title:"ERROR" beep:false style:#(#style_toolwindow,#style_sysmenu)))else(
		if  (((classof $) == SplineShape) or ((classof $) == line)) then(
			 track = $
		     print ("Track : "+(track.name as string))
		     )else((messagebox "Select spline!" title:"ERROR" beep:false style:#(#style_toolwindow,#style_sysmenu)))
		)
	)
on break_front_left pressed do(
	if not selection.count == 1 then((messagebox "Select front left break!" title:"ERROR" beep:false style:#(#style_toolwindow,#style_sysmenu)))else(
		breakFL = $
		print ("Front Left Break : "+(breakFL.name as string))
		)
	)
on break_front_right pressed do(
	if not selection.count == 1 then((messagebox "Select front right break!" title:"ERROR" beep:false style:#(#style_toolwindow,#style_sysmenu)))else(
		breakFR = $
		print ("Front Right Break : "+(breakFR.name as string))
		)
	)
on break_back_left pressed do(
	if not selection.count == 1 then((messagebox "Select back left break!" title:"ERROR" beep:false style:#(#style_toolwindow,#style_sysmenu)))else(
		breakBL = $
		print ("Back Left Break : "+(breakBL.name as string))
		)
	)
on break_back_right pressed do(
	if not selection.count == 1 then((messagebox "Select back right break!" title:"ERROR" beep:false style:#(#style_toolwindow,#style_sysmenu)))else(
		breakBR = $
		print ("Back Right Break : "+(breakBR.name as string))
		)
	)
	
on create pressed do(

try(
undo "CRC" on(
getUnits()

try(print ("---STARTING RIG CREATION FOR " + body.name + "---"))catch(print ("---STARTING RIG CREATION FOR WRONG NODE---"))
	
--pivots positing
print "---PIVOTS POSITING---"
	
CenterPivot wheelFL
	ResetXForm wheelFL
	collapseStack wheelFL
print "-front left wheel: set"
	
CenterPivot wheelFR
	ResetXForm wheelFR
	collapseStack wheelFR
print "-front right wheel: set"
	
CenterPivot wheelBL
	ResetXForm wheelBL
	collapseStack wheelBL
print "-back left wheel: set"
	
CenterPivot wheelBR
	ResetXForm wheelBR
	collapseStack wheelBR
print "-back right wheel: set"

CenterPivot body
body.pivot.z = body.min.z
	ResetXForm body
	collapseStack body
print "-body: set"

try(
breakFL.pivot = wheelFL.pivot
	ResetXForm breakFL
	collapseStack breakFL
print "-front left break: set"
)catch(print "-front left break: not specified")

try(
breakFR.pivot = wheelFR.pivot
	ResetXForm breakFR
	collapseStack breakFR
print "-front right break: set"
)catch(print "-front right break: not specified")

try(
breakBL.pivot = wheelBL.pivot
	ResetXForm breakBL
	collapseStack breakBL
print "-back left break: set"
)catch(print "-back left break: not specified")

try(
breakBR.pivot = wheelBR.pivot
	ResetXForm breakBR
	collapseStack breakBR
print "-back right break: set"
)catch(print "-back right break: not specified")

try(
CenterPivot SW
	ResetXForm SW
	collapseStack SW
local p1 = [SW.pos.x,SW.min.y,SW.max.z]
local p2 = [SW.pos.x,SW.max.y,SW.max.z]
local p3 = [SW.pos.x,SW.max.y,SW.min.z]
RotatePivotOnly SW (EulerAngles (acos ((distance p2 p3)/(distance p1 p3))) 0 0)
print "-steering wheel: set"
)catch(print "-steering wheel: not specified")

--base parameters
print "---BASIC PARAMS---"
wheel_radius = (length [in coordsys local wheelFL.pos.y,in coordsys local wheelFL.min.y])
print ("-wheel radius:"+(wheel_radius as string))
axisY_Lenght = abs ((wheelFL.pos.y)-(wheelBL.pos.y))
print ("-longitudinal axis:"+(axisY_Lenght as string))
axisX_Lenght = abs ((wheelFR.pos.x)-(wheelFL.pos.x))
print ("-transverse axis:"+(axisX_Lenght as string))

--layer creation
try(
crcLayer = layermanager.newLayerFromName ((body.name as string) + "_CRC_helpers")
crcLayer.current = true
crcLayer.renderable = false
crcLayer.lock = true
	
)catch()

--conform space warp
conform_space_warp = ConformSpaceWarp Projection_Distance:0 Selected_Verts:0 Standoff_Distance:wheel_radius Icon_Size:500 pos:[0,0,0]

--normalize path
print "---NORMALIZING TRACK--"
addmodifier track (Normalize_Spline2())
if (curveLength track) <= 10000 do(
	track.Normalize_Spline.length = 1
	print "-track is shorter than 10000: segments set to 1"
	)
if (curveLength track) > 10000 and (curveLength track <= 500000) do(
	track.Normalize_Spline.length = 10
	print "-track is longer than 10000: segments set to 10"
	)
if (curveLength track) > 500000 and (curveLength track <= 50000000) do(
	track.Normalize_Spline.length = 100
	print "-track is longer than 500000: segments set to 100"
	)
if (curveLength track) > 500000000 do(
	track.Normalize_Spline.length = 1000
	print "-track is longer than 500000000: segments set to 1000"
	)
track.vertexTicks = on

print "---CREATING HELPERS---"

--conform plane
conform_plane = Plane name:"conform_plane" length:axisY_Lenght width:axisX_Lenght pos:[(wheelFL.pos.x-axisX_Lenght/2),(wheelFL.pos.y+axisY_Lenght/2),(wheelFL.pos.z)] lengthsegs:1 widthsegs:1 wirecolor:red renderable:false
print "-conform helper: created"

--front axis controller
front_axis_controller = Point name:"front_axis_controller" size:300 pos:[body.pos.x,wheelFL.pos.y,body.pos.z+500] centermarker:false axistripod:false cross:true box:true wirecolor:red 
front_drive = Path_Constraint()
front_axis_controller.position.controller = front_drive
front_drive.follow = true
print "-front axis helper: created"

--back axis controller
back_axis_controller = Point name:"back_axis_controller" size:50 pos:[body.pos.x,wheelBL.pos.y,body.pos.z+500] centermarker:false axistripod:false cross:true box:false wirecolor:blue 
back_drive = Path_Constraint()
back_axis_controller.position.controller = back_drive
back_drive.follow = true
print "-back axis helper: created"

--main controller
middle_controller = Point name:"middle_controller" size:50 pos:[body.pos.x,body.pos.y,body.pos.z+500] centermarker:false axistripod:false cross:true box:false wirecolor:blue 
print "-main helper: created"

--roll controller
roll_controller = Point name:"roll_controller" size:300 pos:body.pos centermarker:false axistripod:true cross:false box:false wirecolor:red 
print "-roll helper: created"

--wheel attach helpers
attachFL_helper = Point name:"attachFL_helper" size:50 pos:wheelFL.pos centermarker:true axistripod:false cross:false box:true wirecolor:blue 
attachFR_helper = Point name:"attachFR_helper" size:50 pos:wheelFR.pos centermarker:true axistripod:false cross:false box:true wirecolor:blue 
attachBL_helper = Point name:"attachBL_helper" size:50 pos:wheelBL.pos centermarker:true axistripod:false cross:false box:true wirecolor:blue 
attachBR_helper = Point name:"attachBR_helper" size:50 pos:wheelBR.pos centermarker:true axistripod:false cross:false box:true wirecolor:blue
print "-attach helpers: created"

--wheel rotation helpers
rotationFL_helper = Point name:"rotationFL_helper" size:100 pos:wheelFL.pos centermarker:false axistripod:false cross:true box:false wirecolor:red 
rotationFR_helper = Point name:"rotationFR_helper" size:100 pos:wheelFR.pos centermarker:false axistripod:false cross:true box:false wirecolor:red 
rotationBL_helper = Point name:"rotationBL_helper" size:100 pos:wheelBL.pos centermarker:false axistripod:false cross:true box:false wirecolor:red 
rotationBR_helper = Point name:"rotationBR_helper" size:100 pos:wheelBR.pos centermarker:false axistripod:false cross:true box:false wirecolor:red 
print "-rotation helpers: created"

--wheel position helpers
positionFL_helper = Point name:"positionFL_helper" size:25 pos:wheelFL.pos centermarker:true axistripod:false cross:false box:true wirecolor:yellow 
positionFR_helper = Point name:"positionFR_helper" size:25 pos:wheelFR.pos centermarker:true axistripod:false cross:false box:true wirecolor:yellow 
positionBL_helper = Point name:"positionBL_helper" size:25 pos:wheelBL.pos centermarker:true axistripod:false cross:false box:true wirecolor:yellow 
positionBR_helper = Point name:"positionBR_helper" size:25 pos:wheelBR.pos centermarker:true axistripod:false cross:false box:true wirecolor:yellow 
print "-position helpers: created"

--steering wheel helpers
try(
rotationSW_helper = Point name:"rotationSW_helper" size:100 rotation:SW.rotation pos:SW.pos centermarker:false axistripod:true cross:false box:false wirecolor:red 
positionSW_helper = Point name:"positionSW_helper" size:100 rotation:SW.rotation pos:SW.pos centermarker:false axistripod:false cross:false box:true wirecolor:blue
print "-steering wheel helper: created"	
)catch(print "-steering wheel helper: skipped")
	
--breaks helpers
try(
breakFL_helper = Point name:"breakFL_helper" size:50 pos:breakFL.pos centermarker:true axistripod:false cross:false box:false wirecolor:blue 
breakFR_helper = Point name:"breakFR_helper" size:50 pos:breakFR.pos centermarker:true axistripod:false cross:false box:false wirecolor:blue
print "-breaks helpers: created"
)catch(print "-breaks helper: skipped")
	
--conform helpers
conformFL_helper = Point name:"conformFL_helper" size:10 pos:[wheelFL.pos.x,wheelFL.pos.y,wheelFL.min.z] centermarker:true axistripod:false cross:false box:true wirecolor:yellow 
conformFR_helper = Point name:"conformFR_helper" size:10 pos:[wheelFR.pos.x,wheelFR.pos.y,wheelFL.min.z] centermarker:true axistripod:false cross:false box:true wirecolor:yellow 
conformBL_helper = Point name:"conformBL_helper" size:10 pos:[wheelBL.pos.x,wheelBL.pos.y,wheelFL.min.z] centermarker:true axistripod:false cross:false box:true wirecolor:yellow 
conformBR_helper = Point name:"conformBR_helper" size:10 pos:[wheelBR.pos.x,wheelBR.pos.y,wheelFL.min.z] centermarker:true axistripod:false cross:false box:true wirecolor:yellow
conformFront_helper = Point name:"conformFront_helper" size:10 pos:[wheelFL.pos.x-(axisX_Lenght/2),wheelFL.pos.y,wheelFL.min.z] centermarker:true axistripod:false cross:false box:true wirecolor:yellow 
conformBack_helper = Point name:"conformBack_helper" size:10 pos:[wheelBL.pos.x-(axisX_Lenght/2),wheelBL.pos.y,wheelBL.min.z] centermarker:true axistripod:false cross:false box:true wirecolor:yellow
conformCenter_helper = Point name:"conformCenter_helper" size:10 pos:[wheelBR.pos.x,wheelBR.pos.y,wheelFL.min.z] centermarker:true axistripod:false cross:false box:true wirecolor:yellow


--conform helpers attachment
conformFL_attachment = attachment()
conformFL_helper.position.controller = conformFL_attachment
conformFL_attachment.node = conform_plane
addNewKey conformFL_attachment 0f
conformFL_pos = AttachCtrl.getkey conformFL_attachment 1
conformFL_pos.face = 1
conformFL_pos.coord = [1,0]

conformFR_attachment = attachment()
conformFR_helper.position.controller = conformFR_attachment
conformFR_attachment.node = conform_plane
addNewKey conformFR_attachment 0f
conformFR_pos = AttachCtrl.getkey conformFR_attachment 1
conformFR_pos.face = 0
conformFR_pos.coord = [0,1]

conformdBL_attachment = attachment()
conformBL_helper.position.controller = conformdBL_attachment
conformdBL_attachment.node = conform_plane
addNewKey conformdBL_attachment 0f
conformBL_pos = AttachCtrl.getkey conformdBL_attachment 1
conformBL_pos.face = 1
conformBL_pos.coord = [0,1]

conformBR_attachment = attachment()
conformBR_helper.position.controller = conformBR_attachment
conformBR_attachment.node = conform_plane
addNewKey conformBR_attachment 0f
conformdBR_pos = AttachCtrl.getkey conformBR_attachment 1
conformdBR_pos.face = 0
conformdBR_pos.coord = [1,0]

conformFront_attachment = attachment()
conformFront_helper.position.controller = conformFront_attachment
conformFront_attachment.node = conform_plane
addNewKey conformFront_attachment 0f
conformFront_pos = AttachCtrl.getkey conformFront_attachment 1
conformFront_pos.face = 1
conformFront_pos.coord = [0.5,0]

conformBack_attachment = attachment()
conformBack_helper.position.controller = conformBack_attachment
conformBack_attachment.node = conform_plane
addNewKey conformBack_attachment 0f
conformBack_pos = AttachCtrl.getkey conformBack_attachment 1
conformBack_pos.face = 0
conformBack_pos.coord = [0.5,0]

conformCenter_attachment = attachment()
conformCenter_helper.position.controller = conformCenter_attachment
conformCenter_attachment.node = conform_plane
addNewKey conformCenter_attachment 0f
conformCenter_pos = AttachCtrl.getkey conformCenter_attachment 1
conformCenter_pos.face = 1
conformCenter_pos.coord = [0,0.5]

print "-conform helpers: created"

--axes creation
front_left_axis_1 = BoneSys.createBone [wheelFL.pos.x-(axisX_Lenght/2),wheelFL.pos.y,wheelFL.pos.z] wheelFL.pos [0,0,1]
front_left_axis_2 = BoneSys.createBone wheelFL.pos [wheelFL.pos.x+5,wheelFL.pos.y,wheelFL.pos.z] [0,0,1]
front_left_axis_2.parent = front_left_axis_1

front_right_axis_1 = BoneSys.createBone [wheelFR.pos.x+(axisX_Lenght/2),wheelFR.pos.y,wheelFR.pos.z] wheelFR.pos [0,0,1]
front_right_axis_2 = BoneSys.createBone wheelFR.pos [wheelFR.pos.x-5,wheelFR.pos.y,wheelFR.pos.z] [0,0,1]
front_right_axis_2.parent = front_right_axis_1

back_left_axis_1 = BoneSys.createBone [wheelBL.pos.x-(axisX_Lenght/2),wheelBL.pos.y,wheelBL.pos.z] wheelBL.pos [0,0,1]
back_left_axis_2 = BoneSys.createBone wheelBL.pos [wheelBL.pos.x+5,wheelBL.pos.y,wheelBL.pos.z] [0,0,1]
back_left_axis_2.parent = back_left_axis_1

back_right_axis_1 = BoneSys.createBone [wheelBR.pos.x+(axisX_Lenght/2),wheelBR.pos.y,wheelBR.pos.z] wheelBR.pos [0,0,1]
back_right_axis_2 = BoneSys.createBone wheelBR.pos [wheelBR.pos.x-5,wheelBR.pos.y,wheelBR.pos.z] [0,0,1]
back_right_axis_2.parent = back_right_axis_1

middle_axis_1 = BoneSys.createBone back_axis_controller.pos front_axis_controller.pos [0,0,1]
middle_axis_2 = BoneSys.createBone front_axis_controller.pos front_axis_controller.pos [0,0,1]
middle_axis_2.parent = middle_axis_1

front_left_ik = IKSys.ikChain front_left_axis_1 front_left_axis_2 "IKHISolver"
front_right_ik = IKSys.ikChain front_right_axis_1 front_right_axis_2 "IKHISolver"
back_left_ik = IKSys.ikChain back_left_axis_1 back_left_axis_2 "IKHISolver"
back_right_ik = IKSys.ikChain back_right_axis_1 back_right_axis_2 "IKHISolver"
middle_ik = IKSys.ikChain middle_axis_1 middle_axis_2 "IKHISolver"

print "-axes: created"

--steering controller
steering_helper = Point name:"steering_helper" size:30 pos:[front_axis_controller.pos.x,front_axis_controller.pos.y,middle_controller.pos.z] centermarker:true axistripod:false cross:false box:false wirecolor:blue 
steering_constraint = Path_Constraint()
steering_helper.position.controller = steering_constraint
steering_constraint.follow = true

print "-steering helper: created"

car_lenght = distance front_axis_controller.pos back_axis_controller.pos

cam = Freecamera fov:80 targetDistance:160 rotation:(quat 0 -0.707107 -0.707107 0) pos:[(body.min.x+((body.max.x-body.min.x)*0.67)),(body.pos.y),(body.min.z+((body.max.z-body.min.z)*0.75))] color:red

print "-camera: created"

--refresh before link
slidertime = slidertime +1
slidertime = 0

print "---LINKING---"
--linking

wheelFL.parent = rotationFL_helper
rotationFL_helper.parent = attachFL_helper
attachFL_helper.parent = positionFL_helper
positionFL_helper.parent = body

attachFL_helper_position = Position_Constraint()
attachFL_helper.position.controller = attachFL_helper_position
attachFL_helper_position.relative = on
attachFL_helper_position.appendTarget conformFL_helper 50
attachFL_helper_position.appendTarget positionFL_helper 50
attachFL_helper_rotation = Orientation_Constraint()
attachFL_helper.rotation.controller = attachFL_helper_rotation
attachFL_helper_rotation.relative = on
attachFL_helper_rotation.appendTarget positionFL_helper 100

wheelFR.parent = rotationFR_helper
rotationFR_helper.parent = attachFR_helper
attachFR_helper.parent = conformFR_helper
positionFR_helper.parent = body

attachFR_helper_position = Position_Constraint()
attachFR_helper.position.controller = attachFR_helper_position
attachFR_helper_position.relative = on
attachFR_helper_position.appendTarget conformFR_helper 50
attachFR_helper_position.appendTarget positionFR_helper 50
attachFR_helper_rotation = Orientation_Constraint()
attachFR_helper.rotation.controller = attachFR_helper_rotation
attachFR_helper_rotation.relative = on
attachFR_helper_rotation.appendTarget positionFR_helper 100

wheelBL.parent = rotationBL_helper
rotationBL_helper.parent = attachBL_helper
attachBL_helper.parent = conformBL_helper
positionBL_helper.parent = body

attachBL_helper_position = Position_Constraint()
attachBL_helper.position.controller = attachBL_helper_position
attachBL_helper_position.relative = on
attachBL_helper_position.appendTarget conformBL_helper 50
attachBL_helper_position.appendTarget positionBL_helper 50
attachBL_helper_rotation = Orientation_Constraint()
attachBL_helper.rotation.controller = attachBL_helper_rotation
attachBL_helper_rotation.relative = on
attachBL_helper_rotation.appendTarget positionBL_helper 100

wheelBR.parent = rotationBR_helper
rotationBR_helper.parent = attachBR_helper
attachBR_helper.parent = conformBR_helper
positionBR_helper.parent = body

attachBR_helper_position = Position_Constraint()
attachBR_helper.position.controller = attachBR_helper_position
attachBR_helper_position.relative = on
attachBR_helper_position.appendTarget conformBR_helper 50
attachBR_helper_position.appendTarget positionBR_helper 50
attachBR_helper_rotation = Orientation_Constraint()
attachBR_helper.rotation.controller = attachBR_helper_rotation
attachBR_helper_rotation.relative = on
attachBR_helper_rotation.appendTarget positionBR_helper 100

print "-wheel linking: done"

try(
breakFL.parent = breakFL_helper
breakFR.parent = breakFR_helper
breakFL_helper.parent = attachFL_helper
breakFR_helper.parent = attachFR_helper
print "-front breaks linking: done"
)catch(print "-front breaks linking: skipped")

try(
breakBL.parent = attachBL_helper
breakBR.parent = attachBR_helper
print "-back breaks linking: done"
)catch(print "-back breaks linking: skipped")
	
try(
SW.parent = rotationSW_helper
rotationSW_helper.parent = positionSW_helper
positionSW_helper.parent = body
print "-steering wheel linking: done"
)catch(print "-steering wheel linking: skipped")
	
front_right_axis_1.parent = conformFront_helper
front_left_axis_1.parent = conformFront_helper
front_right_ik.parent = conformFR_helper
front_left_ik.parent = conformFL_helper

back_right_axis_1.parent = conformBack_helper
back_left_axis_1.parent = conformBack_helper
back_right_ik.parent = conformBR_helper
back_left_ik.parent = conformBL_helper

middle_axis_1.parent = back_axis_controller
middle_ik.parent = front_axis_controller

print "-axes linking: done"

main_position = Position_Constraint()
middle_controller.position.controller = main_position
main_position.appendTarget middle_axis_1 100

main_rotation = Orientation_Constraint()
middle_controller.rotation.controller = main_rotation
main_rotation.appendTarget middle_axis_1 50

roll_position = Position_Constraint()
roll_controller.position.controller = roll_position
roll_position.appendTarget conformFL_helper 50
roll_position.appendTarget conformFR_helper 50
roll_position.appendTarget conformBL_helper 50
roll_position.appendTarget conformBR_helper 50

roll_rotation = Orientation_Constraint()
roll_controller.rotation.controller = roll_rotation
roll_rotation.appendTarget conformCenter_helper 100


print "-controllers linking: done"

conform_plane.parent = middle_controller
body.parent = roll_controller

bindSpaceWarp conform_plane conform_space_warp

print "-conform linking: done"

cam.parent = roll_controller

print "-camera linking: done"

print "---SCRIPTING---"
--scripts
wheelFL_rotationScript = float_script ()
rotationFL_helper.rotation.controller.X_Rotation.controller = wheelFL_rotationScript
wheelFL_rotationScript.addconstant "wheelRadius" wheel_radius
wheelFL_rotationScript.addnode "front_axis" front_axis_controller
wheelFL_rotationScript.addnode "path" track
wheelFL_rotationScript.SetExpression ("(front_axis.position.controller.percent/100)*(curveLength path)/wheelRadius")

wheelFR_rotationScript = float_script ()
rotationFR_helper.rotation.controller.X_Rotation.controller = wheelFR_rotationScript
wheelFR_rotationScript.addconstant "wheelRadius" wheel_radius
wheelFR_rotationScript.addnode "front_axis" front_axis_controller
wheelFR_rotationScript.addnode "path" track
wheelFR_rotationScript.SetExpression ("(front_axis.position.controller.percent/100)*(curveLength path)/wheelRadius")

wheelBL_rotationScript = float_script ()
rotationBL_helper.rotation.controller.X_Rotation.controller = wheelBL_rotationScript
wheelBL_rotationScript.addconstant "wheelRadius" wheel_radius
wheelBL_rotationScript.addnode "back_axis" back_axis_controller
wheelBL_rotationScript.addnode "path" track
wheelBL_rotationScript.SetExpression ("(back_axis.position.controller.percent/100)*(curveLength path)/wheelRadius")

wheelBR_rotationScript = float_script ()
rotationBR_helper.rotation.controller.X_Rotation.controller = wheelBR_rotationScript
wheelBR_rotationScript.addconstant "wheelRadius" wheel_radius
wheelBR_rotationScript.addnode "back_axis" back_axis_controller
wheelBR_rotationScript.addnode "path" track
wheelBR_rotationScript.SetExpression ("(back_axis.position.controller.percent/100)*(curveLength path)/wheelRadius")

wheelFL_steeringScript = float_script ()
rotationFL_helper.rotation.controller.z_Rotation.controller = wheelFL_steeringScript
wheelFL_steeringScript.addnode "steering" steering_helper
wheelFL_steeringScript.addnode "front_axis" front_axis_controller
wheelFL_steeringScript.SetExpression ("degToRad ((((steering.transform * inverse front_axis.transform).rotationPart as EulerAngles).z))")

wheelFR_steeringScript = float_script ()
rotationFR_helper.rotation.controller.z_Rotation.controller = wheelFR_steeringScript
wheelFR_steeringScript.addnode "steering" steering_helper
wheelFR_steeringScript.addnode "front_axis" front_axis_controller
wheelFR_steeringScript.SetExpression ("degToRad ((((steering.transform * inverse front_axis.transform).rotationPart as EulerAngles).z))")

print "-wheel scripts: completed"

try(
breakFL_Script = float_script ()
breakFL_helper.rotation.controller.z_Rotation.controller = breakFL_Script
breakFL_Script.addnode "steering" steering_helper
breakFL_Script.addnode "front_axis" front_axis_controller
breakFL_Script.SetExpression ("degToRad ((((steering.transform * inverse front_axis.transform).rotationPart as EulerAngles).z))")
	
breakFR_Script = float_script ()
breakFR_helper.rotation.controller.z_Rotation.controller = breakFR_Script
breakFR_Script.addnode "steering" steering_helper
breakFR_Script.addnode "front_axis" front_axis_controller
breakFR_Script.SetExpression ("degToRad ((((steering.transform * inverse front_axis.transform).rotationPart as EulerAngles).z))")
print "-breaks scripts: completed"
)catch(print "-breaks scripts: skipped")

try(
SW_steeringScript = float_script ()
rotationSW_helper.rotation.controller.y_Rotation.controller = SW_steeringScript
SW_steeringScript.addnode "steering" steering_helper
SW_steeringScript.addnode "front_axis" front_axis_controller
SW_steeringScript.SetExpression ("degToRad (((steering.transform * inverse front_axis.transform).rotationPart as EulerAngles).z)")
print "-steering wheel scripts: completed"
)catch(print "-steering wheel scripts: skipped")
	
steering_helper_posScript = float_script ()
steering_helper.position.controller.percent.controller = steering_helper_posScript
steering_helper_posScript.addnode "front_axis" front_axis_controller
steering_helper_posScript.addconstant "car_lenght" car_lenght
steering_helper_posScript.addnode "track" track
steering_helper_posScript.SetExpression ("front_axis.position.controller.percent/100+(car_lenght/2)/(curveLength track)")

print "-steering scripts: completed"

back_axis_controller_posScript = float_script ()
back_axis_controller.position.controller.percent.controller = back_axis_controller_posScript
back_axis_controller_posScript.addnode "front_axis" front_axis_controller
back_axis_controller_posScript.addconstant "car_lenght" car_lenght
back_axis_controller_posScript.addnode "track" track
back_axis_controller_posScript.SetExpression ("front_axis.position.controller.percent/100-(car_lenght/(curveLength track))")

print "-axes scripts: completed"

cam_rotScript = float_script ()
cam.rotation.controller.y_Rotation.controller = cam_rotScript
cam_rotScript.addnode "roll" roll_controller
cam_rotScript.SetExpression ("-roll.rotation.x")

cam_posScript = Position_List()
cam.position.controller = cam_posScript
cam_noiseScript = Noise_Position()
cam_posScript.available.controller = cam_noiseScript
cam_noiseScript.frequency = 0.15
cam_noiseScript.noise_strength = [0.05,0.015,0.35]

print "-camera script: completed"

print "---ATTACHING TO TRACK---"
--add track
front_drive.path = track
back_drive.path = track
steering_constraint.path = track

print "-attaching: done"

print "---SETTING SPEED---"

local newSpeed = drive_speed_kmh.value
local currentSpeed = (((distance (at time slidertime front_axis_controller.pos) (at time (slidertime+framerate) front_axis_controller.pos))/unitsType)*3.6)
local ratio = (currentSpeed/newSpeed)

local frame = getKeyTime front_axis_controller.position.controller.percent.controller 2
local key = getKey front_axis_controller.position.controller.percent.controller 2

key.time = frame*ratio

print "-speed: set"

--select conform
select conform_space_warp
max modify mode

--help rollout
rollout help "Help" (
	button helpbtn "HELP" pos:[1,1] width:522 height:308 images:#(@"Z:\-- USERS\Frodo\crc\_images\crc_help.jpg", undefined, 1, 1, 1, 1, 1)
	on helpbtn pressed do(
		destroydialog help
		)
	)
	
--help popup
createdialog help width:522 height:308 style:#(#style_sysmenu)
)
	)catch(
	rollout errorRlt "ERROR" (
		label lbltext "An error occurred, please send this error to:" pos:[45,1]
		hyperLink web "http://www.scriptspot.com/3ds-max/scripts/crc-car-rig-creator" hovercolor:red address:"www.scriptspot.com" pos:[3,20]
		edittext errortext pos:[45,40] width:200
		
		on errorRlt open do(
			local error = getcurrentexception()
			case error of (
				"-- Runtime error: CenterPivot requires a node" : (errortext.text = "ERROR : Wrong car nodes assign" ; print "ERROR : Wrong car nodes assign")
				"-- No \"\"addModifier\"\" function for undefined" : (errortext.text = "ERROR : Wrong path node assign" ; print "ERROR : Wrong path node assign")
				default : (errortext.text = ("UNKNOWN ERROR : " + error) ; print ("UNKNOWN ERROR : " + error))
				)
			)
	    )createdialog errorRlt width:300 height:60 style:#(#style_toolwindow,#style_sysmenu)
	)
)

--manual rollout
rollout PR "Pre-Requirements" (
	bitmap manual1 "" fileName:@"Z:\-- USERS\Frodo\crc\_images\crc_manual1.jpg" pos:[1,15] visible:true
	bitmap manual2 "" fileName:@"Z:\-- USERS\Frodo\crc\_images\crc_manual3.jpg" pos:[1,15] visible:false
	bitmap manual3 "" fileName:@"Z:\-- USERS\Frodo\crc\_images\crc_manual4.jpg" pos:[1,15] visible:false
	bitmap manual4 "" fileName:@"Z:\-- USERS\Frodo\crc\_images\crc_manual5.jpg" pos:[1,15] visible:false
	button pre1btn "STEP 1" pos:[1,1] width:125 height:15
	button pre2btn "STEP 2" pos:[126,1] width:124 height:15
	button pre3btn "STEP 3" pos:[250,1] width:125 height:15
	button pre4btn "STEP 4" pos:[375,1] width:125 height:15

	
	on pre1btn pressed do(
		manual1.visible = true
		manual2.visible = false
		manual3.visible = false
		manual4.visible = false
		)
	on pre2btn pressed do(
		manual1.visible = false
		manual2.visible = true
		manual3.visible = false
		manual4.visible = false
		)
	on pre3btn pressed do(
		manual1.visible = false
		manual2.visible = false
		manual3.visible = true
		manual4.visible = false
		)
	on pre4btn pressed do(
		manual1.visible = false
		manual2.visible = false
		manual3.visible = false
		manual4.visible = true
		)
	)

--manual popup
on pre pressed do(
createdialog PR width:500 height:383 style:#(#style_toolwindow,#style_sysmenu)
)


)createdialog car_rig_creator width:269 height:452 style:#(#style_toolwindow,#style_sysmenu)